#include "ping.h"
//#include "packet.h"
//#include "agent.h"
//#include "iostream.h"

int PingAgent::command(int argc, char** argv)
{
	if(argc>2)
	{
		if(strcmp(argv[1], "sendit")==0)
		{
			Packet* pkt = allocpkt();
			hdr_ping* hdr = (hdr_ping*) pkt->access(off_ping_);
			hdr->ret = 0;
			hdr->send_time = Scheduler::instance().clock();
			send(pkt, 0);
			return (TCL_OK);
			//return -1;
		}
	}
	return (Agent::command(argc, argv));
}

void PingAgent::recv(Packet* pkt, Handler* )
{
	hdr_ip* hdrip = (hdr_ip*) pkt->access(off_ip_);
	hdr_ping* hdr = (hdr_ping*) pkt->access(off_ping_);

	if(hdr->ret == 0)
	{
		double stime = hdr->send_time;
		Packet::free(pkt);
		Packet* pktret = allocpkt();
		hdr_ping* hdrret = (hdr_ping*) pktret->access(off_ping_);
		hdrret->ret = 1;
		hdrret->send_time = stime;

		send(pktret, 0);
	}
	else
	{
		char out[100];
		sprintf(out, "%s recv %d %3.1f", name(),
				hdrip->src_ >> Address::instance().NodeShift_[1],
				(Scheduler::instance().clock()-hdr->send_time*1000));
		Tcl& tcl = Tcl::instance();
		tcl.eval(out);
		Packet::free(pkt);
	}
}

static class PingHeaderClass : public PacketHeaderClass
{
	public:
	PingHeaderClass() : PacketHeaderClass("PacketHeader/Ping", sizeof(hdr_ping)) {;}
} class_pinghdr;

static class PingClass : public TclClass
{
	public:
	PingClass() : TclClass("Agent/Ping") {;}
	TclObject* create(int, const char*const*) {
		return (new PingAgent());
	}
} class_ping;

PingAgent::PingAgent() : Agent(PT_PING)
{
	bind("packetSize_", &size_);
	bind("off_ping_", &off_ping_);
}
